/* 
 * The MIT License (MIT)
 *
 * Copyright (c) 2019 Ha Thach (tinyusb.org)
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 */

#include "bsp/board.h"
#include "tusb.h"
#include "flash.h"
#include "fsm.h"

#if CFG_TUD_MSC

#define MSC_RO_ORIGIN (0x10180000)
#define DISK_BLOCK_NUM 1024
#define DISK_BLOCK_SIZE 512

#define BLOCKS_PER_SECTOR (SPI_FLASH_SECTOR_SIZE / DISK_BLOCK_SIZE)

extern const unsigned char disk0_img[];

struct disk_lba {
    uint8_t data[DISK_BLOCK_SIZE];
};


static const uint8_t last_cluster_init_info[4] = { 0xF8, 0xFF, 0xFF, 0xFF };

const uint8_t disk1_mbr[DISK_BLOCK_SIZE] = {
    0xeb, 0x3c, 0x90, 0x6d, 0x6b, 0x66, 0x73, 0x2e, 0x66, 0x61, 0x74, 0x00,
    0x02, 0x04, 0x01, 0x00, 0x02, 0x00, 0x02, 0x00, 0x04, 0xf8, 0x01, 0x00,
    0x10, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x80, 0x00, 0x29, 0x9d, 0x0b, 0x6e, 0xd0, 'M',  'E',  'P',  ' ',  'V',
    'a',  'u',  'l',  't',  0x20, 0x20, 0x46, 0x41, 0x54, 0x31, 0x32, 0x20,
    0x20, 0x20, 0x0e, 0x1f, 0xbe, 0x5b, 0x7c, 0xac, 0x22, 0xc0, 0x74, 0x0b,
    0x56, 0xb4, 0x0e, 0xbb, 0x07, 0x00, 0xcd, 0x10, 0x5e, 0xeb, 0xf0, 0x32,
    0xe4, 0xcd, 0x16, 0xcd, 0x19, 0xeb, 0xfe, 0x54, 0x68, 0x69, 0x73, 0x20,
    0x69, 0x73, 0x20, 0x6e, 0x6f, 0x74, 0x20, 0x61, 0x20, 0x62, 0x6f, 0x6f,
    0x74, 0x61, 0x62, 0x6c, 0x65, 0x20, 0x64, 0x69, 0x73, 0x6b, 0x2e, 0x20,
    0x20, 0x50, 0x6c, 0x65, 0x61, 0x73, 0x65, 0x20, 0x69, 0x6e, 0x73, 0x65,
    0x72, 0x74, 0x20, 0x61, 0x20, 0x62, 0x6f, 0x6f, 0x74, 0x61, 0x62, 0x6c,
    0x65, 0x20, 0x66, 0x6c, 0x6f, 0x70, 0x70, 0x79, 0x20, 0x61, 0x6e, 0x64,
    0x0d, 0x0a, 0x70, 0x72, 0x65, 0x73, 0x73, 0x20, 0x61, 0x6e, 0x79, 0x20,
    0x6b, 0x65, 0x79, 0x20, 0x74, 0x6f, 0x20, 0x74, 0x72, 0x79, 0x20, 0x61,
    0x67, 0x61, 0x69, 0x6e, 0x20, 0x2e, 0x2e, 0x2e, 0x20, 0x0d, 0x0a, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0xaa
};


// whether host does safe-eject
static bool ejected = false;

static struct disk_lba sector_cache[BLOCKS_PER_SECTOR];
static int sector_cached = -1;

static volatile int cache_busy = 1;

static int sector_cache_load(uint32_t sector)
{
    int ret;
    if (sector * SPI_FLASH_SECTOR_SIZE > DRIVE_FLASH_SIZE) {
        sector_cached = -1;
        return -1;
    }
    ret = flash_decrypt_read_sector(sector, sector_cache[0].data);
    if (ret < 0) {
        sector_cached = -1;
        return ret;
    }
    sector_cached = sector;
    return sector;
}

static inline void sector_cache_sched_commit(void)
{
    cache_busy = 1;
}

static void sector_cache_commit(void)
{
    int ret;
    uint32_t sector = sector_cached;
    if (sector * SPI_FLASH_SECTOR_SIZE > DRIVE_FLASH_SIZE) {
        cache_busy = 0;
        return;
    }
    flash_sector_erase(sector * SPI_FLASH_SECTOR_SIZE + DRIVE_FLASH_OFFSET);
    flash_encrypt_write_sector(sector, sector_cache[0].data);
    cache_busy = 0;
}

struct drive {
    const uint8_t lun;
    const char vid[8];
    const char pid[16];
    const char rev[4];
    const uint32_t n_lba;
};

#define N_DRIVES 2

static uint8_t drv_active[N_DRIVES] = {1, 1};


const char global_vid[8] = "DLX";
const char host_pid[16] = "MEP Tools";
const char vault_pid[16] = "MEP Vault";
const char global_rev[4] = "0.1";

static const struct drive Drives[N_DRIVES] = { 
    { 0, "DLX", "MEP Tools", "0.1", 256},
    { 1, "DLX", "MEP Vault", "0.1", 1024}
};


uint8_t tud_msc_get_maxlun_cb(void)
{
#ifdef HAVE_VAULT
  return 2;
#else
  return 1;
#endif
}

// Invoked when received SCSI_CMD_INQUIRY
// Application fill vendor id, product id and revision with string up to 8, 16, 4 characters respectively
void tud_msc_inquiry_cb(uint8_t lun, uint8_t vendor_id[8], uint8_t product_id[16], uint8_t product_rev[4])
{
    const struct drive *drv;
    if (lun >= N_DRIVES) {
        return;
    }
    drv = &Drives[lun];
    memcpy(vendor_id  , drv->vid, strlen(drv->vid));
    memcpy(product_id , drv->pid, strlen(drv->pid));
    memcpy(product_rev, drv->rev, strlen(drv->rev));
}

// Invoked when received Test Unit Ready command.
// return true allowing host to read/write this LUN e.g SD card inserted
bool tud_msc_test_unit_ready_cb(uint8_t lun)
{
    if (lun >= N_DRIVES) {
        tud_msc_set_sense(lun, SCSI_SENSE_NOT_READY, 0x3a, 0x00);
        return false;
    }
    if (drv_active[lun]) {
        return true;
    } else {
        tud_msc_set_sense(lun, SCSI_SENSE_NOT_READY, 0x3a, 0x00);
        return false;
    }
}

// Invoked when received SCSI_CMD_READ_CAPACITY_10 and SCSI_CMD_READ_FORMAT_CAPACITY to determine the disk size
// Application update block count and block size
void tud_msc_capacity_cb(uint8_t lun, uint32_t* block_count, uint16_t* block_size)
{
    if (lun >= N_DRIVES) {
        *block_count = 0;
        *block_size  = DISK_BLOCK_SIZE;
    } else {
        *block_count = Drives[lun].n_lba;
        *block_size  = DISK_BLOCK_SIZE;
    }
}

// Invoked when received Start Stop Unit command
// - Start = 0 : stopped power mode, if load_eject = 1 : unload disk storage
// - Start = 1 : active mode, if load_eject = 1 : load disk storage
bool tud_msc_start_stop_cb(uint8_t lun, uint8_t power_condition, bool start, bool load_eject)
{
    const struct drive *drv;
    (void) power_condition;

    if (lun < N_DRIVES) {
        drv = &Drives[lun];
        if ( load_eject )
        {
            if (start)
            {
                drv_active[lun] = 1;
            }else
            {
                drv_active[lun] = 0;
            }
        }
    }
    return true;
}

// Callback invoked when received READ10 command.
// Copy disk's data to buffer (up to bufsize) and return number of copied bytes.
int32_t tud_msc_read10_cb(uint8_t lun, uint32_t lba, uint32_t offset, void* buffer, uint32_t bufsize)
{

    const struct drive *drv;
    uint32_t sector, sec_off;
    uint32_t remaining_bufsize = 0, total_bufsize = bufsize;
    if (lun >= N_DRIVES)
        return -1;
    drv = &Drives[lun];

    if ( lba >= drv->n_lba )
        return -1;
    
    if (lun == 0) {
        struct disk_lba *msc_ro = (struct disk_lba *)disk0_img;
        memcpy(buffer, msc_ro[lba].data + offset, bufsize);
        asm volatile("DMB");
        return bufsize;
    } else {
        if (fsm_get() < VAULT_MAIN_MENU) {
            memset(buffer, 0, bufsize);
            return bufsize;
        }
        sector = lba / BLOCKS_PER_SECTOR;
        sec_off = lba - (sector * BLOCKS_PER_SECTOR);
         
        do {
            if ( sector != sector_cached) {
                if (!cache_busy) {
                    if (sector_cache_load(sector) != sector)
                        return -1;
                } else {
                    if (total_bufsize == bufsize)
                        return -1;
                    return total_bufsize - bufsize;
                }
            }
            if (sec_off * DISK_BLOCK_SIZE + offset + bufsize > SPI_FLASH_SECTOR_SIZE) {
                remaining_bufsize = bufsize;
                bufsize = SPI_FLASH_SECTOR_SIZE - (sec_off * DISK_BLOCK_SIZE + offset);
                remaining_bufsize -= bufsize;
            }
            memcpy(buffer, sector_cache[sec_off].data + offset, bufsize);
            asm volatile("DMB");
            if (remaining_bufsize > 0) {
                sector++;
                sec_off = 0;
                bufsize = remaining_bufsize;
                remaining_bufsize = 0;
            } else {
                break;
            }
        } while (bufsize > 0);
        return total_bufsize;
    }
}

bool tud_msc_is_writable_cb (uint8_t lun)
{
    if (lun != 1) {
        /* Read only. */
        return false;
    } else {
        return true;
    }
}

// Callback invoked when received WRITE10 command.
// Process data in buffer to disk's storage and return number of written bytes
int32_t tud_msc_write10_cb(uint8_t lun, uint32_t lba, uint32_t offset, uint8_t* buffer, uint32_t bufsize)
{
    uint32_t sector, sec_off;
    uint32_t remaining_bufsize = 0;
    uint32_t total_bufsize = bufsize;
    if (lun == 0)
        return bufsize;
    if ( lba >= Drives[lun].n_lba)
        return -1;
    if (fsm_get() < VAULT_MAIN_MENU)
        return -1;
    sector = lba / BLOCKS_PER_SECTOR;
    sec_off = lba - (sector * BLOCKS_PER_SECTOR);
    do {
        if ( sector != sector_cached) {
            while(cache_busy)
                sleep_ms(1);
            if (sector_cache_load(sector) < 0)
                return total_bufsize;
        }
        if (bufsize + sec_off * DISK_BLOCK_SIZE + offset > SPI_FLASH_SECTOR_SIZE) {
            remaining_bufsize = bufsize;
            bufsize = SPI_FLASH_SECTOR_SIZE - (sec_off * DISK_BLOCK_SIZE + offset);
            remaining_bufsize -= bufsize;
        } else {
            remaining_bufsize = 0;
        }
        if (bufsize == 0)
            return total_bufsize;
        memcpy(sector_cache[sec_off].data + offset, buffer, bufsize);
        sector_cache_sched_commit();
        if (remaining_bufsize > 0) {
            return total_bufsize;
            /*
            sector++;
            sec_off = 0;
            bufsize = remaining_bufsize;
            remaining_bufsize = 0;
            */
        } else {
            bufsize = 0;
            break;
        }
    } while (bufsize > 0);
    asm volatile("DMB");
    return total_bufsize;
}

// Callback invoked when received an SCSI command not in built-in list below
// - READ_CAPACITY10, READ_FORMAT_CAPACITY, INQUIRY, MODE_SENSE6, REQUEST_SENSE
// - READ10 and WRITE10 has their own callbacks
int32_t tud_msc_scsi_cb (uint8_t lun, uint8_t const scsi_cmd[16], void* buffer, uint16_t bufsize)
{
    // read10 & write10 has their own callback and MUST not be handled here

    void const* response = NULL;
    int32_t resplen = 0;

    // most scsi handled is input
    bool in_xfer = true;

    switch (scsi_cmd[0])
    {
        case SCSI_CMD_PREVENT_ALLOW_MEDIUM_REMOVAL:
            // Host is about to read/write etc ... better not to disconnect disk
            resplen = 0;
            break;

        default:
            // Set Sense = Invalid Command Operation
            tud_msc_set_sense(lun, SCSI_SENSE_ILLEGAL_REQUEST, 0x20, 0x00);

            // negative means error -> tinyusb could stall and/or response with failed status
            resplen = -1;
            break;
    }

    // return resplen must not larger than bufsize
    if ( resplen > bufsize ) resplen = bufsize;

    if ( response && (resplen > 0) )
    {
        if(in_xfer)
        {
            memcpy(buffer, response, resplen);
        }else
        {
            // SCSI output
        }
    }

    return resplen;
}

void disk1_format(void)
{
    uint8_t block[DISK_BLOCK_SIZE];
    int i, j;
    if (cryptoengine_check_vault() < 0)
        return;

    memset(block, 0, DISK_BLOCK_SIZE);
    for (i = 1; i < 5; i++) {
        if (sector_cached != i) {
            if (sector_cache_load(i) < 0)
                break;
        }
        for (j = 0; j < BLOCKS_PER_SECTOR; j++)
            memcpy(sector_cache[j].data, block, DISK_BLOCK_SIZE);
        sector_cache_commit();
    }

    /* Fill "last cluster" info */
    sector_cache_load(0);
    for (j = 0; j < BLOCKS_PER_SECTOR; j++)
            memcpy(sector_cache[j].data, block, DISK_BLOCK_SIZE);
    memcpy(sector_cache[0].data, disk1_mbr, DISK_BLOCK_SIZE);
    memcpy(sector_cache[1].data, last_cluster_init_info, 4); 
    memcpy(sector_cache[2].data, last_cluster_init_info, 4); 
    sector_cache_commit();
}

void disk_crypto_activate(int status)
{
    drv_active[1] = status;
    if (status) {

    }
}

void msc_task(void) {
    if (cache_busy)
        sector_cache_commit();
}

#endif
